# phpMyAdmin MySQL-Dump
# version 2.3.0
# http://phpwizard.net/phpMyAdmin/
# http://www.phpmyadmin.net/ (download page)
#
# Host: localhost
# Erstellungszeit: 16. November 2002 um 12:01
# Server Version: 3.23.51
# PHP-Version: 4.2.1
# Datenbank: `faq`
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_admins`
#

DROP TABLE IF EXISTS faq_admins;
CREATE TABLE faq_admins (
  usernr tinyint(3) unsigned NOT NULL auto_increment,
  username varchar(80) NOT NULL default '',
  password varchar(40) binary NOT NULL default '',
  email varchar(80) NOT NULL default '',
  rights int(2) unsigned NOT NULL default '0',
  lastlogin datetime NOT NULL default '0000-00-00 00:00:00',
  lockpw tinyint(1) unsigned NOT NULL default '0',
  signature text NOT NULL,
  autopin int(10) unsigned NOT NULL default '0',
  language varchar(20) NOT NULL default 'en',
  hideemail tinyint(1) unsigned NOT NULL default '0',
  lockentry tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (usernr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_banlist`
#

DROP TABLE IF EXISTS faq_banlist;
CREATE TABLE faq_banlist (
  bannr int(10) unsigned NOT NULL auto_increment,
  ipadr varchar(16) NOT NULL default '0.0.0.0',
  subnetmask varchar(16) NOT NULL default '0.0.0.0',
  reason text NOT NULL,
  PRIMARY KEY  (bannr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_category`
#

DROP TABLE IF EXISTS faq_category;
CREATE TABLE faq_category (
  catnr int(10) unsigned NOT NULL auto_increment,
  categoryname varchar(240) NOT NULL default '',
  numfaqs int(10) unsigned NOT NULL default '0',
  programm int(10) unsigned default '0',
  displaypos int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (catnr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_category_admins`
#

DROP TABLE IF EXISTS faq_category_admins;
CREATE TABLE faq_category_admins (
  catnr int(10) unsigned NOT NULL default '0',
  usernr int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_category_ref`
#

DROP TABLE IF EXISTS faq_category_ref;
CREATE TABLE faq_category_ref (
  srccatnr int(10) unsigned NOT NULL default '0',
  language varchar(5) NOT NULL default '',
  destcatnr int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_comments`
#

DROP TABLE IF EXISTS faq_comments;
CREATE TABLE faq_comments (
  commentnr int(10) unsigned NOT NULL auto_increment,
  faqnr int(10) unsigned NOT NULL default '0',
  email varchar(140) NOT NULL default '',
  comment text NOT NULL,
  ipadr varchar(16) NOT NULL default '0.0.0.0',
  postdate datetime NOT NULL default '0000-00-00 00:00:00',
  rating int(10) unsigned NOT NULL default '0',
  ratingcount int(10) unsigned NOT NULL default '0',
  views int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (commentnr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_data`
#

DROP TABLE IF EXISTS faq_data;
CREATE TABLE faq_data (
  faqnr int(10) unsigned NOT NULL auto_increment,
  heading varchar(240) NOT NULL default '',
  category int(10) unsigned NOT NULL default '0',
  questiontext text,
  editor varchar(80) NOT NULL default 'unknown',
  editdate date NOT NULL default '0000-00-00',
  answertext text,
  views int(10) unsigned NOT NULL default '0',
  ratingcount int(10) unsigned NOT NULL default '0',
  rating int(10) unsigned NOT NULL default '0',
  displaypos int(10) unsigned NOT NULL default '0',
  subcategory int(10) unsigned NOT NULL default '0',
  linkedfaq int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (faqnr),
  KEY category (category)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_dir_access`
#

DROP TABLE IF EXISTS faq_dir_access;
CREATE TABLE faq_dir_access (
  entrynr int(10) unsigned NOT NULL auto_increment,
  dirname varchar(240) NOT NULL default '',
  PRIMARY KEY  (entrynr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_failed_logins`
#

DROP TABLE IF EXISTS faq_failed_logins;
CREATE TABLE faq_failed_logins (
  loginnr int(10) unsigned NOT NULL auto_increment,
  username varchar(250) NOT NULL default '0',
  ipadr varchar(16) NOT NULL default '',
  logindate datetime NOT NULL default '0000-00-00 00:00:00',
  usedpw varchar(240) NOT NULL default '',
  PRIMARY KEY  (loginnr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_failed_notify`
#

DROP TABLE IF EXISTS faq_failed_notify;
CREATE TABLE faq_failed_notify (
  usernr int(10) unsigned default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_faq_attachs`
#

DROP TABLE IF EXISTS faq_faq_attachs;
CREATE TABLE faq_faq_attachs (
  entrynr int(10) unsigned NOT NULL auto_increment,
  faqnr int(10) unsigned NOT NULL default '0',
  attachnr int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (entrynr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_faq_keywords`
#

DROP TABLE IF EXISTS faq_faq_keywords;
CREATE TABLE faq_faq_keywords (
  faqnr int(10) unsigned NOT NULL default '0',
  keywordnr int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_faq_os`
#

DROP TABLE IF EXISTS faq_faq_os;
CREATE TABLE faq_faq_os (
  faqnr int(10) unsigned NOT NULL default '0',
  osnr int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_faq_prog_version`
#

DROP TABLE IF EXISTS faq_faq_prog_version;
CREATE TABLE faq_faq_prog_version (
  faqnr int(10) unsigned NOT NULL default '0',
  progversion int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_faq_ref`
#

DROP TABLE IF EXISTS faq_faq_ref;
CREATE TABLE faq_faq_ref (
  srcfaqnr int(10) unsigned NOT NULL default '0',
  language varchar(5) NOT NULL default '',
  destfaqnr int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_fileextensions`
#

DROP TABLE IF EXISTS faq_fileextensions;
CREATE TABLE faq_fileextensions (
  entrynr int(10) unsigned NOT NULL auto_increment,
  mimetype int(10) unsigned NOT NULL default '0',
  extension varchar(20) NOT NULL default '',
  PRIMARY KEY  (entrynr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_files`
#

DROP TABLE IF EXISTS faq_files;
CREATE TABLE faq_files (
  entrynr int(10) unsigned NOT NULL auto_increment,
  bindata longblob,
  filename varchar(240) NOT NULL default '',
  mimetype varchar(240) NOT NULL default '',
  filesize int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (entrynr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_filetypedescription`
#

DROP TABLE IF EXISTS faq_filetypedescription;
CREATE TABLE faq_filetypedescription (
  mimetype int(10) unsigned NOT NULL default '0',
  language varchar(10) NOT NULL default '',
  description varchar(80) NOT NULL default '',
  UNIQUE KEY filetypedescription (mimetype,language)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_freemailer`
#

DROP TABLE IF EXISTS faq_freemailer;
CREATE TABLE faq_freemailer (
  entrynr int(10) unsigned NOT NULL auto_increment,
  address varchar(100) NOT NULL default '',
  PRIMARY KEY  (entrynr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_hostcache`
#

DROP TABLE IF EXISTS faq_hostcache;
CREATE TABLE faq_hostcache (
  ipadr varchar(16) NOT NULL default '0',
  hostname varchar(240) NOT NULL default '',
  UNIQUE KEY ipadr (ipadr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_iplog`
#

DROP TABLE IF EXISTS faq_iplog;
CREATE TABLE faq_iplog (
  lognr int(10) unsigned NOT NULL auto_increment,
  usernr int(10) unsigned NOT NULL default '0',
  logtime datetime NOT NULL default '0000-00-00 00:00:00',
  ipadr varchar(16) NOT NULL default '',
  used_lang varchar(4) NOT NULL default '',
  PRIMARY KEY  (lognr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_kb_articles`
#

DROP TABLE IF EXISTS faq_kb_articles;
CREATE TABLE faq_kb_articles (
  articlenr int(10) unsigned NOT NULL auto_increment,
  programm int(10) unsigned NOT NULL default '0',
  heading varchar(240) NOT NULL default '',
  article text NOT NULL,
  ratingcount int(10) unsigned NOT NULL default '0',
  rating int(10) unsigned NOT NULL default '0',
  editor varchar(80) NOT NULL default '',
  lastedited date NOT NULL default '0000-00-00',
  category int(10) unsigned NOT NULL default '0',
  displaypos int(10) unsigned NOT NULL default '0',
  subcategory int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (articlenr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_kb_attachs`
#

DROP TABLE IF EXISTS faq_kb_attachs;
CREATE TABLE faq_kb_attachs (
  entrynr int(10) unsigned NOT NULL auto_increment,
  articlenr int(10) unsigned NOT NULL default '0',
  attachnr int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (entrynr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_kb_cat`
#

DROP TABLE IF EXISTS faq_kb_cat;
CREATE TABLE faq_kb_cat (
  catnr int(10) unsigned NOT NULL auto_increment,
  catname varchar(240) NOT NULL default '',
  heading varchar(250) NOT NULL default '',
  programm int(10) unsigned NOT NULL default '0',
  displaypos int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (catnr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_kb_keywords`
#

DROP TABLE IF EXISTS faq_kb_keywords;
CREATE TABLE faq_kb_keywords (
  articlenr int(10) unsigned NOT NULL default '0',
  keywordnr int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_kb_os`
#

DROP TABLE IF EXISTS faq_kb_os;
CREATE TABLE faq_kb_os (
  articlenr int(10) unsigned NOT NULL default '0',
  osnr int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_kb_prog_version`
#

DROP TABLE IF EXISTS faq_kb_prog_version;
CREATE TABLE faq_kb_prog_version (
  articlenr int(10) unsigned NOT NULL default '0',
  progversion int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_kb_ratings`
#

DROP TABLE IF EXISTS faq_kb_ratings;
CREATE TABLE faq_kb_ratings (
  entrynr int(10) unsigned NOT NULL auto_increment,
  rating int(10) unsigned NOT NULL default '0',
  articlenr int(10) unsigned NOT NULL default '0',
  comment tinytext NOT NULL,
  PRIMARY KEY  (entrynr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_kb_subcat`
#

DROP TABLE IF EXISTS faq_kb_subcat;
CREATE TABLE faq_kb_subcat (
  catnr int(10) unsigned NOT NULL auto_increment,
  catname varchar(240) NOT NULL default '',
  heading varchar(250) NOT NULL default '',
  category int(10) unsigned NOT NULL default '0',
  displaypos int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (catnr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_keywords`
#

DROP TABLE IF EXISTS faq_keywords;
CREATE TABLE faq_keywords (
  keywordnr int(10) unsigned NOT NULL auto_increment,
  keyword varchar(250) NOT NULL default '',
  PRIMARY KEY  (keywordnr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_layout`
#

DROP TABLE IF EXISTS faq_layout;
CREATE TABLE faq_layout (
  layoutnr tinyint(3) unsigned NOT NULL default '0',
  headingbg varchar(8) default NULL,
  bgcolor1 varchar(8) default NULL,
  bgcolor2 varchar(8) default NULL,
  pagebg varchar(8) default NULL,
  tablewidth varchar(10) default NULL,
  fontface varchar(80) default NULL,
  fontsize1 varchar(10) default NULL,
  fontsize2 varchar(10) default NULL,
  fontsize3 varchar(10) default NULL,
  fontcolor varchar(8) default NULL,
  fontsize4 varchar(10) default NULL,
  bgcolor3 varchar(8) default NULL,
  stylesheet varchar(80) default NULL,
  showproglist tinyint(1) unsigned default '1',
  headingfontcolor varchar(8) default NULL,
  subheadingfontcolor varchar(8) default NULL,
  linkcolor varchar(8) default NULL,
  vlinkcolor varchar(8) default NULL,
  alinkcolor varchar(8) default NULL,
  groupfontcolor varchar(8) default NULL,
  tabledescfontcolor varchar(8) default NULL,
  fontsize5 varchar(10) default NULL,
  dateformat varchar(10) default NULL,
  newtime int(4) unsigned default '0',
  newpic varchar(80) default NULL,
  searchpic varchar(80) default NULL,
  printpic varchar(80) default NULL,
  backpic varchar(80) default NULL,
  listpic varchar(80) default NULL,
  watchlogins tinyint(1) unsigned default '1',
  displayrating tinyint(1) unsigned default '0',
  pageheader text,
  pagefooter text,
  usecustomheader tinyint(1) unsigned default '1',
  usecustomfooter tinyint(1) unsigned default '1',
  emailpic varchar(80) default NULL,
  allowemail tinyint(1) unsigned default '1',
  urlautoencode tinyint(1) unsigned NOT NULL default '1',
  enablespcode tinyint(1) unsigned NOT NULL default '1',
  nofreemailer tinyint(1) unsigned NOT NULL default '0',
  allowquestions tinyint(1) unsigned NOT NULL default '1',
  questionpic varchar(80) default NULL,
  faqemail varchar(140) NOT NULL default '',
  allowusercomments tinyint(1) unsigned NOT NULL default '1',
  usercommentpic varchar(80) default NULL,
  newcommentnotify tinyint(1) unsigned NOT NULL default '1',
  allowlists tinyint(1) unsigned NOT NULL default '1',
  allowsearch tinyint(1) unsigned NOT NULL default '1',
  enablefailednotify tinyint(1) unsigned NOT NULL default '0',
  loginlimit int(5) unsigned NOT NULL default '0',
  timezone varchar(10) NOT NULL default 'GMT',
  enablehostresolve tinyint(1) unsigned default '1',
  searchcomments tinyint(1) unsigned NOT NULL default '1',
  searchquestions tinyint(1) unsigned NOT NULL default '1',
  showsummary tinyint(1) unsigned NOT NULL default '1',
  summarylength tinyint(2) unsigned NOT NULL default '40',
  progrestrict tinyint(1) unsigned NOT NULL default '1',
  ratecomments tinyint(1) unsigned NOT NULL default '1',
  footerfile varchar(240) NOT NULL default '',
  headerfile varchar(240) NOT NULL default '',
  printheader tinyint(1) unsigned NOT NULL default '0',
  printfooter tinyint(1) unsigned NOT NULL default '0',
  usemenubar tinyint(1) unsigned NOT NULL default '1',
  mincommentlength int(3) unsigned NOT NULL default '0',
  minquestionlength int(3) unsigned NOT NULL default '0',
  proginfopic varchar(80) NOT NULL default '',
  proginfowidth int(4) unsigned NOT NULL default '0',
  proginfoheight int(4) unsigned NOT NULL default '0',
  textareawidth int(4) unsigned NOT NULL default '0',
  textareaheight int(4) unsigned NOT NULL default '0',
  proginfoleft int(4) unsigned NOT NULL default '0',
  proginfotop int(4) unsigned NOT NULL default '0',
  helpwindowwidth int(4) unsigned NOT NULL default '0',
  helpwindowheight int(4) unsigned NOT NULL default '0',
  helpwindowleft int(4) unsigned NOT NULL default '0',
  helpwindowtop int(4) unsigned NOT NULL default '0',
  helppic varchar(80) NOT NULL default '',
  closepic varchar(80) NOT NULL default '',
  kbmode varchar(20) NOT NULL default 'wizard',
  enablekbrating tinyint(1) unsigned NOT NULL default '0',
  defsearchmethod tinyint(1) unsigned NOT NULL default '0',
  enablekeywordsearch tinyint(1) unsigned NOT NULL default '1',
  enablelanguageselector tinyint(1) unsigned NOT NULL default '0',
  faqsortmethod tinyint(1) unsigned NOT NULL default '0',
  kbsortmethod tinyint(1) unsigned NOT NULL default '0',
  showtimezone tinyint(1) unsigned NOT NULL default '0',
  showcurrtime tinyint(1) unsigned NOT NULL default '0',
  copyrightpos tinyint(1) unsigned NOT NULL default '0',
  copyrightbgcolor varchar(8) NOT NULL default '',
  ascheader text NOT NULL,
  subheadingbgcolor varchar(8) NOT NULL default '',
  actionbgcolor varchar(8) NOT NULL default '',
  headerfilepos tinyint(1) unsigned NOT NULL default '0',
  footerfilepos tinyint(1) unsigned NOT NULL default '0',
  newinfobgcolor varchar(8) NOT NULL default '',
  useascheader tinyint(1) unsigned NOT NULL default '0',
  asclinelength int(4) unsigned NOT NULL default '0',
  ascforcewrap tinyint(1) unsigned NOT NULL default '0',
  addbodytags varchar(240) NOT NULL default '',
  asclistmimetype tinyint(1) unsigned NOT NULL default '0',
  asclistcharset varchar(80) NOT NULL default 'iso-8859-1',
  userquestionanswermode tinyint(1) unsigned NOT NULL default '0',
  userquestionanswermail tinyint(1) unsigned NOT NULL default '0',
  userquestionautopublish tinyint(1) unsigned NOT NULL default '0',
  keywordsearchmode tinyint(1) unsigned NOT NULL default '0',
  questionrequireos tinyint(1) unsigned NOT NULL default '1',
  faqlistshortcuts tinyint(1) unsigned NOT NULL default '0',
  questionrequireversion tinyint(1) unsigned NOT NULL default '0',
  newfaqdisplaymethod tinyint(1) unsigned NOT NULL default '0',
  enablefaqnewdisplay tinyint(1) unsigned NOT NULL default '0',
  faqnewdisplaybgcolor varchar(8) NOT NULL default '',
  faqnewdisplayfontcolor varchar(8) NOT NULL default '',
  listallfaqmethod tinyint(1) unsigned NOT NULL default '0',
  enableshortcutbar tinyint(1) unsigned NOT NULL default '0',
  enablejumpboxes tinyint(1) unsigned NOT NULL default '0',
  subcatbgcolor varchar(8) NOT NULL default '',
  subcatfontcolor varchar(8) NOT NULL default '',
  displayrelated tinyint(1) unsigned NOT NULL default '0',
  htmllisttype int(2) unsigned NOT NULL default '0',
  pagetoppic varchar(80) NOT NULL default 'gfx/top.gif',
  attachpic varchar(80) NOT NULL default 'gfx/attach.gif',
  faqengine_hostname varchar(140) NOT NULL default 'localhost',
  faqlimitrelated tinyint(1) unsigned NOT NULL default '1',
  summaryintotallist tinyint(1) unsigned NOT NULL default '0',
  summarychars tinyint(2) unsigned NOT NULL default '40',
  ratingcomment tinyint(1) unsigned NOT NULL default '0',
  maxentries int(10) unsigned NOT NULL default '0',
  activcellcolor varchar(8) NOT NULL default '#ffff72',
  ratingspublic tinyint(1) unsigned NOT NULL default '0',
  ratingcommentpublic tinyint(1) unsigned NOT NULL default '0',
  hovercells tinyint(1) unsigned NOT NULL default '0',
  nosunotify tinyint(1) unsigned NOT NULL default '0',
  qesautopub tinyint(1) unsigned NOT NULL default '0',
  ns4style varchar(240) NOT NULL default 'faq_ns4.css',
  ns6style varchar(240) NOT NULL default 'faq_ns6.css',
  operastyle varchar(240) NOT NULL default 'faq_opera.css',
  geckostyle varchar(240) NOT NULL default 'faq_gecko.css',
  konquerorstyle varchar(240) NOT NULL default 'faq_konqueror.css',
  blockoldbrowser tinyint(1) unsigned NOT NULL default '1',
  bbccolorbar tinyint(1) unsigned NOT NULL default '1',
  ascheaderfile varchar(240) NOT NULL default '',
  ascheaderfilepos tinyint(1) unsigned NOT NULL default '0',
  numlatest tinyint(4) unsigned NOT NULL default '10',
  colorscrollbars tinyint(1) unsigned NOT NULL default '1',
  sbfacecolor varchar(7) NOT NULL default '#94AAD6',
  sbhighlightcolor varchar(7) NOT NULL default '#AFEEEE',
  sbshadowcolor varchar(7) NOT NULL default '#ADD8E6',
  sb3dlightcolor varchar(7) NOT NULL default '#1E90FF',
  sbarrowcolor varchar(7) NOT NULL default '#0000ff',
  sbtrackcolor varchar(7) NOT NULL default '#E0FFFF',
  sbdarkshadowcolor varchar(7) NOT NULL default '#4682B4',
  pagebgpic varchar(240) NOT NULL default '',
  tabledescfontsize varchar(20) NOT NULL default '10pt',
  langselectfontsize varchar(20) NOT NULL default '10pt',
  faqnewfontsize varchar(20) NOT NULL default '10pt',
  jumpboxfontsize varchar(20) NOT NULL default '10pt',
  actionlinefontsize varchar(20) NOT NULL default '9pt',
  newinfofontsize varchar(20) NOT NULL default '9pt',
  newinfofontcolor varchar(7) NOT NULL default '#000000',
  shortbarfontsize varchar(20) NOT NULL default '9pt',
  jumpboxsorting tinyint(4) unsigned NOT NULL default '0',
  disableasclist tinyint(1) unsigned NOT NULL default '0',
  disablehtmlemail tinyint(1) unsigned NOT NULL default '1',
  admstorefaqfilters tinyint(1) unsigned NOT NULL default '1',
  contentcopy varchar(250) NOT NULL default '',
  pagebgattach varchar(80) NOT NULL default 'scroll',
  pagebgrepeat varchar(80) NOT NULL default 'repeat',
  pagebgposition varchar(80) NOT NULL default 'top',
  admhideunassigned tinyint(1) unsigned NOT NULL default '0',
  subcatfontsize varchar(10) NOT NULL default '12pt',
  admdelconfirm tinyint(1) unsigned NOT NULL default '0',
  questionshorting int(10) unsigned NOT NULL default '20',
  zlibavail tinyint(1) unsigned NOT NULL default '0',
  defmailsig text NOT NULL,
  msendlimit int(10) unsigned NOT NULL default '30',
  cc_font varchar(80) NOT NULL default '"Times New Roman", Times, serif',
  cc_fontsize varchar(20) NOT NULL default '12pt',
  cc_fontcolor varchar(7) NOT NULL default '',
  maxconfirmtime int(4) unsigned NOT NULL default '2',
  subscriptionpic varchar(240) NOT NULL default 'gfx/subscribe.gif',
  irow_bgcolor varchar(7) NOT NULL default '#ADD8E6',
  irow_fontcolor varchar(7) NOT NULL default '#808100',
  irow_fontsize varchar(20) NOT NULL default '12pt',
  subscriptionavail tinyint(1) unsigned NOT NULL default '1',
  pagenavfontcolor varchar(7) NOT NULL default '#000000',
  pagenavfontsize varchar(20) NOT NULL default '9pt',
  admedoptions int(10) unsigned NOT NULL default '0',
  subcatfontstyle tinyint(2) unsigned NOT NULL default '1',
  linkoptions tinyint(4) unsigned NOT NULL default '0',
  listoptions tinyint(4) unsigned NOT NULL default '0',
  clist_linkcolor varchar(7) NOT NULL default '#000000',
  clist_vlinkcolor varchar(7) NOT NULL default '#000000',
  clist_alinkcolor varchar(7) NOT NULL default '#000000',
  allsendcompressed tinyint(1) unsigned NOT NULL default '0',
  shownextprev tinyint(1) unsigned NOT NULL default '0',
  nextprevmode tinyint(1) unsigned NOT NULL default '0',
  uq_allownoemail tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (layoutnr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_mimetypes`
#

DROP TABLE IF EXISTS faq_mimetypes;
CREATE TABLE faq_mimetypes (
  entrynr int(10) unsigned NOT NULL auto_increment,
  mimetype varchar(240) NOT NULL default '',
  icon varchar(240) NOT NULL default '',
  PRIMARY KEY  (entrynr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_misc`
#

DROP TABLE IF EXISTS faq_misc;
CREATE TABLE faq_misc (
  shutdown tinyint(3) unsigned NOT NULL default '0',
  shutdowntext text
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_os`
#

DROP TABLE IF EXISTS faq_os;
CREATE TABLE faq_os (
  osnr int(10) unsigned NOT NULL auto_increment,
  osname varchar(180) NOT NULL default '',
  PRIMARY KEY  (osnr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_prog_dirs`
#

DROP TABLE IF EXISTS faq_prog_dirs;
CREATE TABLE faq_prog_dirs (
  prognr int(10) unsigned NOT NULL default '0',
  dirnr int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_prog_os`
#

DROP TABLE IF EXISTS faq_prog_os;
CREATE TABLE faq_prog_os (
  osnr int(10) unsigned NOT NULL default '0',
  prognr int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_programm`
#

DROP TABLE IF EXISTS faq_programm;
CREATE TABLE faq_programm (
  prognr int(10) unsigned NOT NULL auto_increment,
  programmname varchar(240) NOT NULL default '',
  numcats int(10) unsigned default '0',
  progid varchar(10) NOT NULL default '',
  language varchar(5) NOT NULL default 'de',
  newsgroup varchar(250) NOT NULL default '',
  newssubject varchar(80) default NULL,
  nntpserver varchar(80) default NULL,
  newsdomain varchar(80) default NULL,
  description text NOT NULL,
  displaypos int(10) unsigned NOT NULL default '0',
  lastmailed date NOT NULL default '0000-00-00',
  htmlmailtype tinyint(1) unsigned NOT NULL default '0',
  subscriptionavail tinyint(1) unsigned NOT NULL default '1',
  PRIMARY KEY  (prognr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_programm_admins`
#

DROP TABLE IF EXISTS faq_programm_admins;
CREATE TABLE faq_programm_admins (
  prognr int(10) unsigned NOT NULL default '0',
  usernr int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_programm_version`
#

DROP TABLE IF EXISTS faq_programm_version;
CREATE TABLE faq_programm_version (
  entrynr int(10) unsigned NOT NULL auto_increment,
  programm int(10) unsigned NOT NULL default '0',
  version varchar(20) NOT NULL default '',
  PRIMARY KEY  (entrynr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_questions`
#

DROP TABLE IF EXISTS faq_questions;
CREATE TABLE faq_questions (
  questionnr int(10) unsigned NOT NULL auto_increment,
  prognr int(10) unsigned NOT NULL default '0',
  osname varchar(180) default NULL,
  versionnr varchar(10) default NULL,
  email varchar(140) NOT NULL default '',
  question text NOT NULL,
  enterdate datetime NOT NULL default '0000-00-00 00:00:00',
  faqref int(10) unsigned default '0',
  posterip varchar(20) NOT NULL default '',
  answerdate datetime NOT NULL default '0000-00-00 00:00:00',
  answerauthor int(10) unsigned NOT NULL default '0',
  answer text NOT NULL,
  language varchar(5) NOT NULL default 'de',
  questionref int(10) unsigned NOT NULL default '0',
  publish tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (questionnr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_ratings`
#

DROP TABLE IF EXISTS faq_ratings;
CREATE TABLE faq_ratings (
  entrynr int(10) unsigned NOT NULL auto_increment,
  rating int(10) unsigned NOT NULL default '0',
  faqnr int(10) unsigned NOT NULL default '0',
  comment tinytext NOT NULL,
  PRIMARY KEY  (entrynr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_related_categories`
#

DROP TABLE IF EXISTS faq_related_categories;
CREATE TABLE faq_related_categories (
  srccat int(10) unsigned NOT NULL default '0',
  destcat int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_related_faq`
#

DROP TABLE IF EXISTS faq_related_faq;
CREATE TABLE faq_related_faq (
  srcfaq int(10) unsigned NOT NULL default '0',
  destfaq int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_related_subcat`
#

DROP TABLE IF EXISTS faq_related_subcat;
CREATE TABLE faq_related_subcat (
  srccat int(10) unsigned NOT NULL default '0',
  destcat int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_session`
#

DROP TABLE IF EXISTS faq_session;
CREATE TABLE faq_session (
  sessid int(10) unsigned NOT NULL default '0',
  usernr int(10) NOT NULL default '0',
  starttime int(10) unsigned NOT NULL default '0',
  remoteip varchar(15) NOT NULL default '',
  lastlogin datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (sessid),
  KEY sess_id (sessid),
  KEY start_time (starttime),
  KEY remote_ip (remoteip)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_subcategory`
#

DROP TABLE IF EXISTS faq_subcategory;
CREATE TABLE faq_subcategory (
  catnr int(10) unsigned NOT NULL auto_increment,
  categoryname varchar(240) NOT NULL default '',
  category int(10) unsigned default '0',
  displaypos int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (catnr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_subscriptions`
#

DROP TABLE IF EXISTS faq_subscriptions;
CREATE TABLE faq_subscriptions (
  subscriptionnr int(10) unsigned NOT NULL auto_increment,
  email varchar(240) NOT NULL default '',
  confirmed int(1) unsigned NOT NULL default '0',
  language varchar(4) NOT NULL default '',
  subscribeid int(10) unsigned NOT NULL default '0',
  unsubscribeid int(10) unsigned NOT NULL default '0',
  enterdate datetime NOT NULL default '0000-00-00 00:00:00',
  emailtype tinyint(1) unsigned NOT NULL default '1',
  progid varchar(10) NOT NULL default '',
  compression tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (subscriptionnr)
) TYPE=MyISAM;
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `faq_texts`
#

DROP TABLE IF EXISTS faq_texts;
CREATE TABLE faq_texts (
  textnr int(10) unsigned NOT NULL auto_increment,
  textid varchar(20) NOT NULL default '',
  lang varchar(4) NOT NULL default '',
  text text NOT NULL,
  PRIMARY KEY  (textnr)
) TYPE=MyISAM;

