<?php
/***************************************************************************
 * (c)2001,2002 Boesch IT-Consulting (info@boesch-it.de)
 ***************************************************************************/
require_once('../config.php');
require_once('./auth.php');
if(!isset($$langvar) || !$$langvar)
	$act_lang=$admin_lang;
else
	$act_lang=$$langvar;
include_once('./language/lang_'.$act_lang.'.php');
$page_title=$l_failed_logins;
$page="loginfailures";
require_once('./heading.php');
$sql = "select * from ".$tableprefix."_layout where (layoutnr=1)";
if(!$result = faqe_db_query($sql, $db)) {
    die("Could not connect to the database.");
}
if ($myrow = faqe_db_fetch_array($result))
{
	$dateformat=$myrow["dateformat"];
	$dateformat.=" H:i:s";
	$enablehostresolve=$myrow["enablehostresolve"];
}
else
{
	$dateformat="Y-m-d H:i:s";
	$enablehostresolve=1;
}
if(!isset($storefaqfilter) && ($admstorefaqfilters==1))
{
	$admcookievals="";
	if($new_global_handling)
	{
		if(isset($_COOKIE[$admcookiename]))
			$admcookievals = $_COOKIE[$admcookiename];
	}
	else
	{
		if(isset($HTTP_COOKIE_VARS[$admcookiename]))
			$admcookievals = $HTTP_COOKIE_VARS[$admcookiename];
	}
	if($admcookievals)
	{
		if(faqe_array_key_exists($admcookievals,"lf_sorting"))
			$sorting=$admcookievals["lf_sorting"];
	}
}
if(!isset($sorting))
	$sorting=5;
?>
<table align="center" width="80%" CELLPADDING="1" CELLSPACING="0" border="0" valign="top">
<tr><TD BGCOLOR="#000000">
<?php
if($enable_htaccess)
{
	echo "<table align=\"center\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\">";
	echo "<tr class=\"errorrow\" align=\"center\"><td>";
	echo "$l_notavail_htaccess";
	echo "</td></tr></table></td></tr></table>";
	include('./trailer.php');
	exit;
}
if(isset($mode))
{
	if($mode=="hostnames")
	{
		if($enablehostresolve!=1)
		{
			echo "<tr class=\"errorrow\"><td align=\"center\">";
			die("$l_functionnotallowed");
		}
		$sql = "select * from ".$tableprefix."_failed_logins";
		if(!$result = faqe_db_query($sql, $db)) {
			echo "<tr class=\"errorrow\"><td align=\"center\">";
		    die("Could not connect to the database.");
		}
		if ($myrow = faqe_db_fetch_array($result))
		{
			do{
				$acthostname=gethostname($myrow["ipadr"],$db,true);
			}while($myrow=faqe_db_fetch_array($result));
		}
		echo "<table align=\"center\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\">";
		echo "<tr class=\"displayrow\" align=\"center\"><td>";
		echo "$l_hostnames_resolved";
		echo "</td></tr></table></td></tr></table>";
		echo "<div class=\"bottombox\" align=\"center\"><a href=\"".do_url_session("$act_script_url?$langvar=$act_lang")."\">$l_failed_logins</a></div>";
	}
	if($mode=="resolve")
	{
		if($enablehostresolve!=1)
		{
			echo "<tr class=\"errorrow\"><td align=\"center\">";
			die("$l_functionnotallowed");
		}
		$sql = "select * from ".$tableprefix."_failed_logins where loginnr=$input_loginnr";
		if(!$result = faqe_db_query($sql, $db)) {
			echo "<tr class=\"errorrow\"><td align=\"center\">";
		    die("Could not connect to the database.");
		}
		if ($myrow = faqe_db_fetch_array($result))
		{
			$acthostname=gethostname($myrow["ipadr"],$db,true);
		}
		echo "<table align=\"center\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\">";
		echo "<tr class=\"displayrow\" align=\"center\"><td>";
		echo "$l_hostnames_resolved";
		echo "</td></tr></table></td></tr></table>";
		echo "<div class=\"bottombox\" align=\"center\"><a href=\"".do_url_session("$act_script_url?$langvar=$act_lang")."\">$l_failed_logins</a></div>";
	}
	if($mode=="display")
	{
		if($admin_rights < 3)
		{
			echo "<tr class=\"errorrow\"><td align=\"center\">";
			die("$l_functionnotallowed");
		}
?>
<table align="center" width="100%" border="0" cellspacing="1" cellpadding="1">
<?
		$sql = "select * from ".$tableprefix."_failed_logins where (loginnr=$input_loginnr)";
		if(!$result = faqe_db_query($sql, $db))
		    die("<tr class=\"errorrow\"><td>Could not connect to the database.");
		if (!$myrow = faqe_db_fetch_array($result))
			die("<tr class=\"errorrow\"><td>no such entry");
?>
<tr class="headingrow"><td align="center" colspan="2"><b><?php echo $l_displayfailedlogin?></b></td></tr>
<tr class="displayrow"><td align="right" width="30%"><?php echo $l_username?>:</td><td><?php echo $myrow["username"]?></td></tr>
<tr class="displayrow"><td align="right"><?php echo $l_ipadr?>:</td><td><?php echo $myrow["ipadr"]?></td></tr>
<tr class="displayrow"><td align="right"><?php echo $l_hostname?>:</td><td><?php echo gethostname($myrow["ipadr"],$db,false)?></td></tr>
<?php
		list($mydate,$mytime)=explode(" ",$myrow["logindate"]);
		list($year, $month, $day) = explode("-", $mydate);
		list($hour, $min, $sec) = explode(":",$mytime);
		if($month>0)
			$displaydate=date($dateformat,mktime($hour,$min,$sec,$month,$day,$year));
		else
			$displaydate="";
?>
<tr class="displayrow"><td align="right"><?php echo $l_date?>:</td><td><?php echo $displaydate?></td></tr>
<?php
		echo "</table></td></tr></table>";
		echo "<div class=\"bottombox\" align=\"center\"><a href=\"".do_url_session("$act_script_url?$langvar=$act_lang")."\">$l_failed_logins</a></div>";
	}
	if($mode=="delete")
	{
		if($admin_rights < 3)
		{
			echo "<tr class=\"errorrow\"><td align=\"center\">";
			die("$l_functionnotallowed");
		}
?>
<table align="center" width="100%" border="0" cellspacing="1" cellpadding="1">
<?php
		$deleteSQL = "delete from ".$tableprefix."_failed_logins where (loginnr=$input_loginnr)";
		$success = faqe_db_query($deleteSQL,$db);
		if (!$success)
			die("<tr class=\"errorrow\"><td>$l_cantdelete.");
		echo "<tr class=\"displayrow\" align=\"center\"><td>";
		echo "$l_deleted<br>";
		echo "</td></tr></table></td></tr></table>";
		echo "<div class=\"bottombox\" align=\"center\"><a href=\"".do_url_session("$act_script_url?$langvar=$act_lang")."\">$l_failed_logins</a></div>";
	}
	if($mode=="clear")
	{
		if($admin_rights < 3)
		{
			echo "<tr class=\"errorrow\"><td align=\"center\">";
			die("$l_functionnotallowed");
		}
?>
<table align="center" width="100%" border="0" cellspacing="1" cellpadding="1">
<?php
		$deleteSQL = "delete from ".$tableprefix."_failed_logins";
		$success = faqe_db_query($deleteSQL,$db);
		if (!$success)
			die("<tr class=\"errorrow\"><td>$l_cantdelete.");
		echo "<tr class=\"displayrow\" align=\"center\"><td>";
		echo "$l_entries $l_deleted<br>";
		echo "</td></tr></table></td></tr></table>";
		echo "<div class=\"bottombox\" align=\"center\"><a href=\"".do_url_session("$act_script_url?$langvar=$act_lang")."\">$l_failed_logins</a></div>";
	}
}
else
{
?>
<table align="center" width="100%" border="0" cellspacing="1" cellpadding="1">
<?
if($admin_rights<3)
{
	echo "<tr class=\"errorrow\"><td align=\"center\">";
	die("$l_functionnotallowed");
}
$sql = "select * from ".$tableprefix."_failed_logins ";
switch($sorting)
{
	case 1:
		$sql.="order by username desc";
		break;
	case 2:
		$sql.="order by ipadr asc";
		break;
	case 3:
		$sql.="order by ipadr desc";
		break;
	case 4:
		$sql.="order by logindate asc";
		break;
	case 5:
		$sql.="order by logindate desc";
		break;
	default:
		$sql.="order by username asc";
		break;
}
if(!$result = faqe_db_query($sql, $db)) {
	echo "<tr class=\"errorrow\"><td align=\"center\">";
    die("Could not connect to the database.");
}
if (!$myrow = faqe_db_fetch_array($result))
{
	echo "<tr class=\"displayrow\"><td align=\"center\" colspan=\"3\">";
	echo $l_noentries;
	echo "</td></tr></table></td></tr></table>";
}
else
{
	$myurl="$act_script_url?$langvar=$act_lang";
	if($admstorefaqfilters==1)
		$myurl.="&storefaqfilter=1";
	echo "<tr class=\"rowheadings\">";
	echo "<td align=\"center\">";
	if($sorting==0)
		$sorturl="&sorting=1";
	else
		$sorturl="&sorting=0";
	echo "<a class=\"rowheadings\" href=\"".do_url_session($myurl.$sorturl)."\">";
	echo "<b>$l_username</b></a>";
	if($sorting==0)
		echo "<img src=\"gfx/down.gif\" border=\"0\" align=\"absmiddle\">";
	if($sorting==1)
		echo "<img src=\"gfx/up.gif\" border=\"0\" align=\"absmiddle\">";
	echo "</td>";
	echo "<td class=\"rowheadings\" align=\"center\"><b>$l_password</b></td>";
	echo "<td align=\"center\">";
	if($sorting==3)
		$sorturl="&sorting=2";
	else
		$sorturl="&sorting=3";
	echo "<a class=\"rowheadings\" href=\"".do_url_session($myurl.$sorturl)."\">";
	echo "<b>$l_ipadr</b></a>";
	if($sorting==2)
		echo "<img src=\"gfx/down.gif\" border=\"0\" align=\"absmiddle\">";
	if($sorting==3)
		echo "<img src=\"gfx/up.gif\" border=\"0\" align=\"absmiddle\">";
	echo "</td>";
	if($enablehostresolve==1)
		echo "<td class=\"rowheadings\" align=\"center\"><b>$l_hostname</b></td>";
	echo "<td align=\"center\">";
	if($sorting==5)
		$sorturl="&sorting=4";
	else
		$sorturl="&sorting=5";
	echo "<a class=\"rowheadings\" href=\"".do_url_session($myurl.$sorturl)."\">";
	echo "<b>$l_date</b></a>";
	if($sorting==4)
		echo "<img src=\"gfx/down.gif\" border=\"0\" align=\"absmiddle\">";
	if($sorting==5)
		echo "<img src=\"gfx/up.gif\" border=\"0\" align=\"absmiddle\">";
	echo "</td>";
	echo "<td>&nbsp;</td></tr>";
		do {
		$act_id=$myrow["loginnr"];
		if($myrow["logindate"]>$userdata["lastlogin"])
			echo "<tr class=\"displayrownew\">";
		else
			echo "<tr class=\"displayrow\">";
		list($mydate,$mytime)=explode(" ",$myrow["logindate"]);
		list($year, $month, $day) = explode("-", $mydate);
		list($hour, $min, $sec) = explode(":",$mytime);
		if($month>0)
			$displaydate=date($dateformat,mktime($hour,$min,$sec,$month,$day,$year));
		else
			$displaydate="";
		echo "<td width=\"15%\" align=\"center\">".$myrow["username"]."</td>";
		echo "<td width=\"15%\" align=\"center\">".$myrow["usedpw"]."</td>";
		echo "<td width=\"15%\" align=\"center\">";
		$hostname=gethostname($myrow["ipadr"],$db,false);
		if((strlen($hostname)<1) && ($enablehostresolve==1))
			echo " <a class=\"listlink2\" href=\"".do_url_session("$act_script_url?mode=resolve&input_loginnr=$act_id&$langvar=$act_lang")."\">";
		echo $myrow["ipadr"];
		if((strlen($hostname)<1) && ($enablehostresolve==1))
			echo "</a>";
		echo "</td>";
		if($enablehostresolve==1)
			echo "<td width=\"20%\" align=\"center\">".$hostname."</td>";
		echo "<td width=\"15%\" align=\"center\">$displaydate</td>";
		echo "<td>";
		echo "<a class=\"listlink2\" href=\"".do_url_session("$act_script_url?mode=display&$langvar=$act_lang&input_loginnr=$act_id")."\">";
		echo "$l_display</a>";
		echo "&nbsp; ";
		echo "<a class=\"listlink2\" href=\"".do_url_session("$act_script_url?mode=delete&input_loginnr=$act_id&$langvar=$act_lang")."\">";
		echo "$l_delete</a>";
		if(!isbanned($myrow["ipadr"],$db))
		{
			echo "&nbsp; ";
			echo "<a class=\"listlink\" href=\"".do_url_session("banlist?mode=newadr&subnetmask=255.255.255.255&ipadr=".$myrow["ipadr"]."&lang=$lang")."\">";
			echo "$l_banip</a>";
		}
		echo "</td></tr>";
		} while($myrow = faqe_db_fetch_array($result));
	if($enablehostresolve==1)
	{
		echo "<tr class=\"actionrow\"><td align=\"center\" colspan=\"6\">";
		echo "<a href=\"".do_url_session("$act_script_url?$langvar=$act_lang&mode=hostnames")."\">";
		echo "$l_determine_hostnames</a></td></tr>";
	}
	echo "</table></tr></td></table>";
	echo "<div class=\"bottombox\" align=\"center\"><a href=\"".do_url_session("$act_script_url?$langvar=$act_lang&mode=clear")."\">$l_clearentries</a></div>";
}
}
include('./trailer.php');
?>